_F='pod_name'
_E='max_version'
_D='platform'
_C='presigned_urls'
_B=True
_A=False
import json,logging
from dataclasses import dataclass
from typing import Dict,List,Optional,Tuple
from localstack import constants
from localstack.utils.files import new_tmp_file
from localstack.utils.http import download,safe_requests
from localstack.utils.strings import to_str
from plugin import Plugin,PluginManager
from requests import Response
from localstack_ext.bootstrap import licensing
from localstack_ext.bootstrap.pods.client_api import CloudPodPreSignedUrls,CloudPodsClientApi
LOG=logging.getLogger(__name__)
@dataclass
class RemoteConfig:remote_url:str
PODS_REMOTE_NAMESPACE='localstack.pods.remote'
class CloudPodsRemote(Plugin):
	namespace=PODS_REMOTE_NAMESPACE;name:str;protocols:set[str];remote_config:RemoteConfig;pods_api:CloudPodsClientApi
	def load(A,*B,**C):A.remote_config=B[1];A.pods_api=CloudPodsClientApi(B[0])
	def list_pods(A):raise NotImplementedError
	def get_max_version(A,pod_name):raise NotImplementedError
	def pull_versions(A,pod_name,required_versions):raise NotImplementedError
	def is_registered(A,pod_name):raise NotImplementedError
	def push_pod(A,pod_name,version,overwrite=_A):raise NotImplementedError
	def register_remote(A,pod_name,ci_pod=None):raise NotImplementedError
	def rename_pod(A,current_name,new_name):raise NotImplementedError
	def delete_pod(A,pod_name):raise NotImplementedError
def create_platform_url(path=None):
	A=path;B=f"{constants.API_ENDPOINT}/cloudpods"
	if not A:return B
	A=A if A.startswith('/')else f"/{A}";return f"{B}{A}"
class CloudPodsRemotePlatform(CloudPodsRemote):
	name=_D;protocols={_D}
	def get_max_version(B,pod_name):
		C=create_platform_url(pod_name);D=licensing.get_auth_headers();A=safe_requests.get(url=C,headers=D);E='Failed to get version information from platform.. aborting'
		if not B._check_response(A,message=E,raise_error=_B):return
		F=json.loads(A.content);G=int(F[_E]);return G
	def pull_versions(A,pod_name,required_versions):
		C=','.join(str(A)for A in required_versions);D=create_platform_url(f"{pod_name}/data?versions={C}");E=licensing.get_auth_headers();B=safe_requests.get(url=D,headers=E);F='Failed to pull requested versions from platform (code <status_code>)'
		if not A._check_response(B,message=F,raise_error=_B):return
		G=json.loads(B.content);H,I,I=A._prepare_archives_from_pre_signed_urls(G.get(_C));A.pods_api.merge_from_remote(versions_archive=H)
	def push_pod(A,pod_name,version,overwrite=_A):
		B=create_platform_url(f"{pod_name}/data?version={version}")
		if overwrite:B+='&overwrite=true'
		D=licensing.get_auth_headers();C=safe_requests.post(url=B,headers=D);E='Failed to get pre-signed URLs to upload new version: <content> (status <status_code>)'
		if not A._check_response(C,message=E,raise_error=_B):return
		F=json.loads(C.content);G=F.get(_C);A.pods_api.upload_pod_to_pre_signed_urls(pre_signed_urls=G)
	def list_pods(B):C=licensing.get_auth_headers();D=create_platform_url();A=safe_requests.get(D,headers=C);B._check_response(A,message='Error fetching list of pods from API (status <status_code>)',raise_error=_B);E=json.loads(A.content);return E
	def delete_pod(D,pod_name):A=create_platform_url(pod_name);B=licensing.get_auth_headers();C=safe_requests.delete(url=A,headers=B);return C.ok
	def is_registered(G,pod_name):
		A=pod_name
		try:C=create_platform_url();D=licensing.get_auth_headers();B=safe_requests.get(C,headers=D)
		except Exception as E:LOG.debug('An error occurred while checking remote management for pod "%s": "%s"',A,E);return _A
		if not B.ok:return _A
		F=json.loads(B.content);return A in[A[_F]for A in F]
	def register_remote(A,pod_name,ci_pod=None):
		B=pod_name;E=A.pods_api.get_max_version_no();F=licensing.get_auth_headers();G=create_platform_url(B);C={_F:B,_E:E,'ci_pod':ci_pod};C=json.dumps(C);D=safe_requests.put(G,C,headers=F);H=f"Failed to register pod {B}: <content>"
		if not A._check_response(D,message=H):return _A
		I=json.loads(D.content);J=I.get(_C);A.pods_api.upload_pod_to_pre_signed_urls(pre_signed_urls=J);return _B
	def rename_pod(D,current_name,new_name):C=new_name;B=current_name;E=licensing.get_auth_headers();F=create_platform_url(f"{B}/rename");A={'new_pod_name':C};A=json.dumps(A);G=safe_requests.put(F,A,headers=E);H=f"Failed to rename {B} to {C}: <content>";return D._check_response(G,message=H)
	@classmethod
	def _check_response(C,response,message,raise_error=_A):
		B=response;A=message
		if B.ok:return _B
		if B.status_code in[401,403]:raise Exception('Access denied - please log in first.')
		A=A.replace('<content>',to_str(B.content));A=A.replace('<status_code>',str(B.status_code))
		if raise_error:raise Exception(A)
		LOG.warning(A);return _A
	@staticmethod
	def _prepare_archives_from_pre_signed_urls(pre_signed_urls):A=pre_signed_urls;B=new_tmp_file();E=A.get('versions_archive_url');download(url=E,path=B);C=new_tmp_file();F=A.get('state_archive_url');download(url=F,path=C);D=new_tmp_file();G=A.get('metadata_archive_url');download(url=G,path=D);return B,C,D
class CloudPodsRemoteManager(PluginManager[CloudPodsRemote]):
	protocols_to_plugin:dict[str,Plugin]
	def __init__(A,*D,**E):
		super().__init__(PODS_REMOTE_NAMESPACE,load_args=D,load_kwargs=E);A.protocols_to_plugin={};F=A.load_all()
		for C in F:
			G=C.protocols
			for B in G:
				if B in A.protocols_to_plugin:LOG.info('A plugin is already registered for protocol %s => overriding.',B)
				A.protocols_to_plugin[B]=C;LOG.debug('Mapping %s protocol to %s',B,C)
	def get_plugin_for_protocol(A,protocol):return A.protocols_to_plugin.get(protocol)